%define		STDC_VERSION 2.10.0
Summary:	GNU Compiler Collection
Name:		gcc
Version:	2.95.3
Release:	1
License:	GPL
Group:		Development/Languages
Packager:       linuxkid <linux@peanutlinux.org>
Source0:	ftp://gcc.gnu.org/pub/gcc/releases/gcc-%{version}/%{name}-%{version}.tar.gz
Source1:	gcov.1
Patch0:		%{name}-info.patch
Patch1:		%{name}-pld-linux.patch
Patch2:		%{name}-libstdc++.patch
Patch3:		%{name}-bootstrap.patch
Patch4:		%{name}-cpp-macro-doc.patch
Patch5:		%{name}-default-arch.patch
Patch6:		%{name}-libstdc++-out-of-mem.patch
Patch7:		%{name}-libstdc++-wstring.patch
Patch8:		%{name}-libstdc++-bastring.patch
Patch9:		%{name}-manpage.patch
Patch10:	%{name}-cpp-dos-newlines.patch
Patch11:	%{name}-gpc.patch
Patch12:	%{name}-m68k-pic.patch
Patch13:	%{name}-sparc32-rfi.patch
Patch14:	%{name}-builtin-apply.patch
Patch15:	%{name}-ppc-ice.patch
Patch16:	%{name}-ppc-descriptions.patch
Patch17:	%{name}-alpha-complex-float.patch
Patch18:	%{name}-gcj-vs-iconv.patch
Patch19:	%{name}-libobjc.patch
Patch20:	%{name}-pointer-arith.patch
Patch21:	%{name}-crtendS.patch

%define		_sysconfdir	/etc

BuildRequires:	bison texinfo binutils
URL:		http://gcc.gnu.org/
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
A compiler aimed at integrating all the optimizations and features
necessary for a high-performance and stable development environment.

%package c++
Summary:	C++ support for gcc
Group:		Development/Languages
Obsoletes:	egcc-c++
Obsoletes:	egcs-c++

%description c++
This package adds C++ support to the GNU C compiler. It includes
support for most of the current C++ specification, including templates
and exception handling. It does not include a standard C++ library,
which is available separately.

%package objc
Summary:	Objective C support for gcc
Group:		Development/Languages
Obsoletes:	egcc-objc
Obsoletes:	egcs-objc

%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is a object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
objective C object library.

%package g77
Summary:	Fortran 77 support for gcc
Group:		Development/Languages
Obsoletes:	egcs-g77

%description g77
This apckage adds support for compiling Fortran 77 programs with the
GNU compiler.

%package chill
Summary:	CHILL support for gcc
Group:		Development/Languages

%description chill
This package adds support for compiling CHILL programs with the GNU
compiler.

Chill is the "CCITT High-Level Language", where CCITT is the old name
for what is now ITU, the International Telecommunications Union. It is
is language in the Modula2 family, and targets many of the same
applications as Ada (especially large embedded systems). Chill was
never used much in the United States, but is still being used in
Europe, Brazil, Korea, and other places.

%package java
Summary:	Java support for gcc
Group:		Development/Languages

%description java
This package adds experimental support for compiling Java(tm) programs
and bytecode into native code. To use this you will also need the
libgcj package.

%package libstdc++
Summary:	GNU c++ library
Group:		Libraries
Version:	%{STDC_VERSION}
Obsoletes:	libg++

%description libstdc++
This is the GNU implementation of the standard C++ libraries, along
with additional GNU tools. This package includes the shared libraries
necessary to run C++ applications.

%package libstdc++-devel
Summary:	Header files and libraries for C++ development
Group:		Development/Libraries
Version:	%{STDC_VERSION}

%description libstdc++-devel
This is the GNU implementation of the standard C++ libraries. This
package includes the header files and libraries needed for C++
development.

%package cpp
Summary:	The C Pre Processor
Group:		Development/Languages
Obsoletes:	egcs-cpp

%description cpp
The C preprocessor is a "macro processor" that is used automatically
by the C compiler to transform your program before actual compilation.
It is called a macro processor because it allows you to define
"macros", which are brief abbreviations for longer constructs.

%package infoman
Summary:	Information and manual pages.
Group:		Documentaion

%description infoman
The Documentation for gcc, g++, cpp, g77 & gcov.

The C preprocessor provides four separate facilities that you can use
as you see fit:

- Inclusion of header files. These are files of declarations that can
  be substituted into your program.
- Macro expansion. You can define "macros", which are abbreviations
  for arbitrary fragments of C code, and then the C preprocessor will
  replace the macros with their definitions throughout the program.
- Conditional compilation. Using special preprocessing directives, you
  can include or exclude parts of the program according to various
  conditions.
- Line control. If you use a program to combine or rearrange source
  files into an intermediate file which is then compiled, you can use
  line control to inform the compiler of where each source line
  originally came from.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p1
%ifarch m68k
%patch12 -p0
%endif
%ifarch sparc sparc32
%patch13 -p0
%patch14 -p0
%endif
%ifarch ppc
%patch15 -p0
%patch16 -p0
%endif
%ifarch alpha
%patch17 -p1
%endif
%patch18 -p0
%patch19 -p0
%patch20 -p0
%patch21 -p1

%build
(cd gcc; autoconf)
rm -rf obj-%{_target_platform}
install -d obj-%{_target_platform} && cd obj-%{_target_platform} 

CFLAGS="%{?debug:-O0 -g}%{!?debug:$RPM_OPT_FLAGS}" \
CXXFLAGS="%{?debug:-O0 -g}%{!?debug:$RPM_OPT_FLAGS}" \
TEXCONFIG=false ../configure \
	--prefix=%{_prefix} \
	--infodir=%{_infodir} \
	--enable-shared \
%ifnarch sparc sparc64
	--enable-threads=posix \
	--enable-haifa \
%endif
	--with-gnu-as \
	--with-gnu-ld \
	--with-gxx-include-dir="\$\{prefix\}/include/g++" \
	--without-included-gettext \
	--disable-nls \
	%{_target_platform}

PATH=$PATH:/sbin:%{_sbindir}
touch  ../gcc/c-gperf.h

cd ..
%{__make} -C obj-%{_target_platform} bootstrap \
	LDFLAGS_FOR_TARGET="%{!?debug:-s}" \
	mandir=%{_mandir} \
	infodir=%{_infodir}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/lib,%{_datadir}}

cd obj-%{_target_platform}
PATH=$PATH:/sbin:%{_sbindir}

%{__make} install \
	prefix=$RPM_BUILD_ROOT%{_prefix} \
	mandir=$RPM_BUILD_ROOT%{_mandir} \
	infodir=$RPM_BUILD_ROOT%{_infodir}

%{__make} install \
	prefix=$RPM_BUILD_ROOT%{_prefix} \
	mandir=$RPM_BUILD_ROOT%{_mandir} \
	infodir=$RPM_BUILD_ROOT%{_infodir} -C texinfo

ln -sf gcc $RPM_BUILD_ROOT%{_bindir}/cc
ln -sf gcc $RPM_BUILD_ROOT%{_bindir}/egcc
ln -sf gcc $RPM_BUILD_ROOT%{_bindir}/egcs
ln -sf g++ $RPM_BUILD_ROOT%{_bindir}/egcs++
ln -sf g++ $RPM_BUILD_ROOT%{_bindir}/egcs-cpp

echo .so g77.1 > $RPM_BUILD_ROOT%{_mandir}/man1/f77.1
echo .so cccp.1 > $RPM_BUILD_ROOT%{_mandir}/man1/cpp.1
install %{SOURCE1} $RPM_BUILD_ROOT%{_mandir}/man1/

ln -sf g77 $RPM_BUILD_ROOT%{_bindir}/f77
(cd $RPM_BUILD_ROOT%{_libdir} ; ln -sf libstdc++.so.*.*.* $RPM_BUILD_ROOT%{_libdir}/libstdc++.so)
ln -sf %{_bindir}/cpp $RPM_BUILD_ROOT/lib/cpp

cd $RPM_BUILD_ROOT/usr/i386-pc-linux
rmdir include
ln -sf ../include include

strip -R.comment -R.note $RPM_BUILD_ROOT/bin/* 2>/dev/null || : 
strip -R.comment -R.note $RPM_BUILD_ROOT/sbin/* 2>/dev/null || :
strip -R.comment -R.note $RPM_BUILD_ROOT/lib/*.so 2>/dev/null || :
strip -R.comment -R.note $RPM_BUILD_ROOT/usr/bin/* 2>/dev/null || :
strip -R.comment -R.note $RPM_BUILD_ROOT/usr/sbin/* 2>/dev/null || :
strip -R.comment -R.note $RPM_BUILD_ROOT/usr/lib/*.so 2>/dev/null || :
strip -R.comment -R.note $RPM_BUILD_ROOT/usr/local/bin/* 2>/dev/null || :
strip -R.comment -R.note $RPM_BUILD_ROOT/usr/local/sbin/* 2>/dev/null || :
strip -R.comment -R.note $RPM_BUILD_ROOT/usr/local/lib/*.so 2>/dev/null || :
strip -R.comment -R.note $RPM_BUILD_ROOT/usr/X11R6/bin/* 2>/dev/null || :
strip -R.comment -R.note $RPM_BUILD_ROOT/usr/X11R6/lib/*.so 2>/dev/null || :

%post
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1

%postun
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1

%post g77
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1

%postun g77
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1

%post chill
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1

%postun chill
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1

%post cpp
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1

%postun cpp
[ ! -x /usr/sbin/fix-info-dir ] || /usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1

%post   -p /sbin/ldconfig libstdc++
%postun -p /sbin/ldconfig libstdc++

%clean
rm -rf $RPM_BUILD_ROOT

%files

%dir %{_libdir}/gcc-lib
%dir %{_libdir}/gcc-lib/%{_target_cpu}*
%dir %{_libdir}/gcc-lib/%{_target_cpu}*/*
%dir %{_libdir}/gcc-lib/%{_target_cpu}*/*/include
/usr/i386-pc-linux
%attr(755,root,root) %{_bindir}/%{_target_cpu}*-gcc
%attr(755,root,root) %{_bindir}/gcc
%attr(755,root,root) %{_bindir}/gcov
%attr(755,root,root) %{_bindir}/protoize
%attr(755,root,root) %{_bindir}/unprotoize
%attr(755,root,root) %{_bindir}/cc
%attr(755,root,root) %{_bindir}/egcc
%attr(755,root,root) %{_bindir}/egcs

%{_libdir}/gcc-lib/%{_target_cpu}*/*/SYSCALLS.c.X
%attr(755,root,root) %{_libdir}/gcc-lib/%{_target_cpu}*/*/cc1
%{_libdir}/gcc-lib/%{_target_cpu}*/*/libgcc.a
%{_libdir}/gcc-lib/%{_target_cpu}*/*/lib*.map
%{_libdir}/gcc-lib/%{_target_cpu}*/*/specs

%ifnarch alpha
%attr(755,root,root) %{_libdir}/gcc-lib/%{_target_cpu}*/*/crt*.o
%endif

%attr(755,root,root) %{_libdir}/gcc-lib/%{_target_cpu}*/*/collect2

%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/float.h
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/iso646.h
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/limits.h
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/proto.h
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/stdarg.h
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/stdbool.h
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/stddef.h
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/syslimits.h
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/va-*.h
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/varargs.h

%files c++

%attr(755,root,root) %{_bindir}/g++
%attr(755,root,root) %{_bindir}/c++
%attr(755,root,root) %{_bindir}/egcs++
%attr(755,root,root) %{_bindir}/egcs-cpp

%attr(755,root,root) %{_bindir}/c++filt
%attr(755,root,root) %{_libdir}/gcc-lib/%{_target_cpu}*/*/cc1plus

%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/exception
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/new
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/typeinfo
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/new.h

%files objc

%attr(755,root,root) %{_libdir}/gcc-lib/%{_target_cpu}*/*/cc1obj

%{_libdir}/gcc-lib/%{_target_cpu}*/*/libobjc.a
%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/objc

%files g77

%attr(755,root,root) %{_bindir}/g77
%attr(755,root,root) %{_bindir}/f77

%attr(755,root,root) %{_libdir}/gcc-lib/%{_target_cpu}*/*/f771
%{_libdir}/gcc-lib/%{_target_cpu}*/*/libg2c.a

%{_libdir}/gcc-lib/%{_target_cpu}*/*/include/g2c.h

%files chill

%attr(755,root,root) %{_bindir}/chill

%attr(755,root,root) %{_libdir}/gcc-lib/%{_target_cpu}*/*/cc1chill
%attr(755,root,root) %{_libdir}/gcc-lib/%{_target_cpu}*/*/chill*.o
%{_libdir}/gcc-lib/%{_target_cpu}*/*/libchill.a

%files java

%attr(755,root,root) %{_bindir}/gcj
%attr(755,root,root) %{_bindir}/gcjh
%attr(755,root,root) %{_bindir}/jcf-dump
%attr(755,root,root) %{_bindir}/jv-scan

%attr(755,root,root) %{_libdir}/gcc-lib/%{_target_cpu}*/*/jc1
%attr(755,root,root) %{_libdir}/gcc-lib/%{_target_cpu}*/*/jvgenmain

%files libstdc++
%attr(755,root,root) %{_libdir}/libstdc++.so.*.*.*
%attr(755,root,root) %{_libdir}/libstdc++.so

%files libstdc++-devel
%attr(644,root,root) %{_libdir}/libstdc++.a
%{_includedir}/g++

%files cpp
%attr(755,root,root) /lib/cpp
%attr(755,root,root) %{_bindir}/cpp
%attr(755,root,root) %{_libdir}/gcc-lib/%{_target_cpu}*/*/cpp0

%files infoman
/usr/info
/usr/man
